<?php

namespace LaraBB\Settings\UI\Web\Requests\Prefix;

use Illuminate\Foundation\Http\FormRequest;
use Illuminate\Http\RedirectResponse;

/**
 * Class Update
 * @package LaraBB\Settings\UI\Web\Requests\Prefix
 */
class Update extends FormRequest
{
    /**
     * @return bool
     */
    public function authorize(): bool
    {
        return true;
    }

    /**
     * @return array
     */
    public function rules(): array
    {
        return [
            'uuid'          => 'required|uuid|exists:settings_prefixes,uuid',
            'prefix'        => 'required',
            'display_style' => 'required',
            'forums'        => 'required'
        ];
    }

    /**
     * @return array
     */
    public function messages(): array
    {
        return [
            'uuid.required'          => 'Es wurde keine UUID übergeben.',
            'uuid.uuid'              => 'Die übergebene UUID ist ungültig.',
            'uuid.exists'            => 'Der zu bearbeitende Präfix existiert nicht.',
            'prefix.required'        => 'Bitte geben Sie einen Präfix an!',
            'display_style.required' => 'Bitte geben Sie einen Anzeigestil an!',
            'forums.required'        => 'Bitte geben Sie Foren an, in denen der Präfix verfügbar sein soll.'
        ];
    }

    /**
     * @return RedirectResponse
     */
    public function success(): RedirectResponse
    {
        return redirect()->route('admin.settings.prefix.edit', [$this->post('uuid')])->with([
            'success' => 'Der Präfix wurde erfolgreich bearbeitet.'
        ]);
    }

    /**
     * @return RedirectResponse
     */
    public function failed(): RedirectResponse
    {
        return redirect()->route('admin.settings.prefix.edit', [$this->post('uuid')])->with([
            'error' => 'Der Präfix konnte aufgrund einer technischen Störung nicht bearbeitet werden.'
        ])->withInput();
    }
}
